Index: palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4893)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! revised output of surface data via MPI-IO for better performance
+!
+! 4857 2021-01-26 07:24:41Z raasch
 ! bugfix: allocation of 3d-int4 array moved from particle output to standard output
 !
@@ -155,6 +158,4 @@
                myidx,                                                                              &
                myidy,                                                                              &
-               npex,                                                                               &
-               npey,                                                                               &
                numprocs,                                                                           &
                pdims
@@ -183,8 +184,5 @@
     INTEGER(iwp)            ::  fh = -1          !< MPI-IO file handle
 #if defined( __parallel )
-    INTEGER(iwp)            ::  fhs = -1         !< MPI-IO file handle to open file with comm2d always
-#endif
     INTEGER(iwp)            ::  ft_surf = -1     !< MPI filetype surface data
-#if defined( __parallel )
     INTEGER(iwp)            ::  ft_2di_nb        !< MPI filetype 2D array INTEGER no outer boundary
     INTEGER(iwp)            ::  ft_2d            !< MPI filetype 2D array REAL with outer boundaries
@@ -196,9 +194,4 @@
     INTEGER(iwp)            ::  glo_start        !< global start index on this PE
 #if defined( __parallel )
-    INTEGER(iwp)            ::  local_start      !<
-#endif
-    INTEGER(iwp)            ::  nr_iope          !<
-    INTEGER(iwp)            ::  nr_val           !< local number of values in x and y direction
-#if defined( __parallel )
     INTEGER(iwp)            ::  win_2di          !<
     INTEGER(iwp)            ::  win_2dr          !<
@@ -207,4 +200,8 @@
     INTEGER(iwp)            ::  win_3dr          !<
     INTEGER(iwp)            ::  win_3ds          !<
+    INTEGER(iwp)            ::  win_end   = -1   !<
+    INTEGER(iwp)            ::  win_glost = -1   !<
+    INTEGER(iwp)            ::  win_out   = -1   !<
+    INTEGER(iwp)            ::  win_start = -1   !<
     INTEGER(iwp)            ::  win_surf = -1    !<
 #endif
@@ -216,12 +213,26 @@
     INTEGER(iwp), DIMENSION(:,:), POINTER, CONTIGUOUS   ::  array_2di   !<
 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_end_index     !<
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_global_start  !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  e_end_index     !< extended end index, every grid cell has at least one value
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  e_start_index   !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_end_index     !< module copy of end_index
     INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  m_start_index   !<
+    INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  thread_index    !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  target_thread   !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  transfer_index  !<
+    INTEGER(iwp), DIMENSION(:),   ALLOCATABLE ::  thread_values   !<
+!
+!-- Indices for cyclic fill
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  o_start_index   !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  c_start_index   !<
+!#if defined( __parallel )
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  o_end_index     !< extended end index, every grid cell has at least one value
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  c_end_index     !< extended end index, every grid cell has at least one value
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  c_global_start  !<
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  c_global_end    !<
+!#endif
 
     INTEGER(isp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  array_3di4  !<
     INTEGER(idp), DIMENSION(:,:,:), POINTER, CONTIGUOUS ::  array_3di8  !<
 
-    LOGICAL ::  all_pes_write                 !< all PEs have data to write
     LOGICAL ::  filetypes_created             !<
     LOGICAL ::  io_on_limited_cores_per_node  !< switch to shared memory MPI-IO
@@ -229,4 +240,9 @@
     LOGICAL ::  wr_flag                       !< file is opened for write
 
+#if defined( __parallel )
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE       :: local_indices
+#endif
+
+    REAL(wp), DIMENSION(:), POINTER, CONTIGUOUS     ::  array_out      !<
 #if defined( __parallel )
     REAL(wp), DIMENSION(:), POINTER, CONTIGUOUS     ::  array_1d       !<
@@ -251,9 +267,11 @@
        INTEGER(iwp) :: nr_int         !< number of INTEGER entries in header
        INTEGER(iwp) :: nr_real        !< number of REAL entries in header
+       INTEGER(iwp) :: pes_along_x    !< number of PEs along x-direction during writing restart file
+       INTEGER(iwp) :: pes_along_y    !< number of PEs along y-direction during writing restart file
        INTEGER(iwp) :: total_nx       !< total number of points in x-direction
        INTEGER(iwp) :: total_ny       !< total number of points in y-direction
     END TYPE general_header
 
-    TYPE(general_header), TARGET ::  tgh    !<
+    TYPE(general_header), TARGET, PUBLIC ::  tgh    !<
 
     TYPE(sm_class)               ::  sm_io  !<
@@ -421,5 +439,4 @@
             wrd_mpi_io_surface
 
-
  CONTAINS
 
@@ -452,4 +469,5 @@
     TYPE(C_PTR)                   ::  buf_ptr  !<
 #endif
+
 
     offset = 0
@@ -467,5 +485,5 @@
     io_file_name = file_name
 !
-!-- Setup for IO on a limited number of threads per node (using shared memory MPI)
+!-- Setup for IO on a limited number of PEs per node (using shared memory MPI)
     IF ( rd_flag )  THEN
        set_filetype = .TRUE.
@@ -822,6 +840,6 @@
 
 !
-!--    TODO: describe in more detail what is done here and why it is done
-!--    save grid of main run
+!--    Save grid information of the mainrun, i.e. grid variables like nxl, nxr, nys, nyn and other
+!--    values are stored within the mainrun_grid structure
        CALL mainrun_grid%save_grid_into_this_class()
 
@@ -834,5 +852,5 @@
        rma_offset_s = 0
 !
-!--    Determine, if gridpoints of the prerun are located on this thread.
+!--    Determine, if gridpoints of the prerun are located on this PE.
 !--    Set the (cyclic) prerun grid.
        nxr = MIN( nxr, nx_on_file )
@@ -857,5 +875,5 @@
        ny = ny_on_file
 !
-!--    Determine, if this thread is doing IO
+!--    Determine, if this PE is doing IO
        IF ( nnx > 0  .AND.  nny > 0 )  THEN
           color = 1
@@ -892,5 +910,5 @@
 #endif
 !
-!--    Allocate 2d buffers as RMA window, accessible on all threads
+!--    Allocate 2d buffers as RMA window, accessible on all PEs
        IF ( pe_active_for_read )  THEN
           ALLOCATE( rmabuf_2di(nys:nyn,nxl:nxr) )
@@ -918,5 +936,5 @@
 
 !
-!--    Allocate 3d buffer as RMA window, accessable on all threads
+!--    Allocate 3d buffer as RMA window, accessable on all PEs
        IF ( pe_active_for_read )  THEN
           ALLOCATE( rmabuf_3d(nzb:nzt+1,nys:nyn,nxl:nxr) )
@@ -932,6 +950,7 @@
 
 !
-!--    TODO: comment in more detail, what is done here, and why
-!--    save small grid
+!--    Save grid of the prerun, i.e. grid variables like nxl, nxr, nys, nyn and other values
+!--    are stored within the prerun_grid structure.
+!--    The prerun grid can later be activated by calling prerun_grid%activate_grid_from_this_class()
        CALL prerun_grid%save_grid_into_this_class()
        prerun_grid%comm2d = comm_cyclic_fill
@@ -1152,6 +1171,4 @@
 
 
-!kk       write(9,*) 'Here is rma_cylic_fill_real_2d ',nxl,nxr,nys,nyn; FLUSH(9)
-
 !
 !--    Reading 2d real array on prerun grid
@@ -1297,6 +1314,6 @@
 !--                  array would be dimensioned in the caller subroutine like this:
 !--                  INTEGER, DIMENSION(nysg:nyng,nxlg:nxrg)::  data
-          message_string = '2d-INTEGER array "' // TRIM( name ) // '" to be read from restart ' // &
-                           'file is defined with illegal dimensions in the PALM code'
+          message_string = '2d-INTEGER array with nbgp "' // TRIM( name ) // '" to be read ' //    &
+                           'from restart file is defined with illegal dimensions in the PALM code'
           CALL message( 'rrd_mpi_io_int_2d', 'PA0723', 3, 2, 0, 6, 0 )
 
@@ -1374,11 +1391,14 @@
 
 
-       CALL prerun_grid%activate_grid_from_this_class()
-
        IF ( pe_active_for_read )  THEN
+          CALL prerun_grid%activate_grid_from_this_class()
+
 #if defined( __parallel )
           CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_INTEGER, ft_2di_nb, 'native',            &
                                   MPI_INFO_NULL, ierr )
           CALL MPI_FILE_READ_ALL( fh, array_2di, SIZE( array_2di ), MPI_INTEGER, status, ierr )
+#else
+          CALL posix_lseek( fh, array_position )
+          CALL posix_read( fh, array_2di, SIZE( array_2di ) )
 #endif
           DO  i = nxl, nxr
@@ -1386,7 +1406,7 @@
           ENDDO
           data(1:nny,1:nnx) = rmabuf_2di
-       ENDIF
-
-       CALL mainrun_grid%activate_grid_from_this_class()
+
+          CALL mainrun_grid%activate_grid_from_this_class()
+       ENDIF
 
 #if defined( __parallel )
@@ -1396,43 +1416,8 @@
 #endif
 
-       IF ( .NOT. pe_active_for_read )  THEN
-
-          is = nxl
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ELSE
-
-          is = nxl
-          ie = nxr
-          js = prerun_grid%nys+1
-          je = nyn
-          DO  i = is, ie
-             DO  j = js, je
-                i_remote = MOD(i,nx_on_file+1)
-                j_remote = MOD(j,ny_on_file+1)
-                rem_pe   = remote_pe(i_remote,j_remote)
-                rem_offs = rma_offset(i_remote,j_remote)
-                nval     = 1
-
-#if defined( __parallel )
-                IF ( rem_pe /= myid )  THEN
-                   CALL MPI_GET( data(j-nys+1,i-nxl+1), nval, MPI_INTEGER, rem_pe, rem_offs, nval, &
-                                 MPI_INTEGER, rmawin_2di, ierr )
-                ELSE
-                   data(j-nys+1,i-nxl+1) = rmabuf_2di(j_remote,i_remote)
-                ENDIF
-#else
-                data(j-nys+1,i-nxl+1) = array_2di(i_remote,j_remote)
-#endif
-             ENDDO
-          ENDDO
-          is = prerun_grid%nxr+1
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ENDIF
+       is = nxl
+       ie = nxr
+       js = nys
+       je = nyn
 
        DO  i = is, ie
@@ -1717,4 +1702,7 @@
                                   ierr )
           CALL MPI_FILE_READ_ALL( fh, array_3d, SIZE( array_3d ), MPI_REAL, status, ierr )
+#else
+          CALL posix_lseek( fh, array_position )
+          CALL posix_read( fh, array_3d, SIZE( array_3d ) )
 #endif
           DO  i = nxl, nxr
@@ -1727,53 +1715,17 @@
 #if defined( __parallel )
 !
-!--     Close RMA window to allow remote access
-        CALL MPI_WIN_FENCE( 0, rmawin_3d, ierr )
-#endif
-
-       IF ( .NOT. pe_active_for_read )  THEN
-
-          is = nxl
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ELSE
-
-          is = nxl
-          ie = nxr
-          js = prerun_grid%nys+1
-          je = nyn
-
-          DO  i = is, ie
-             DO  j = js, je
-                i_remote = MOD(i,nx_on_file+1)
-                j_remote = MOD(j,ny_on_file+1)
-                rem_pe   = remote_pe(i_remote,j_remote)
-                rem_offs = rma_offset(i_remote,j_remote)*(nzt-nzb+2)
-                nval     = nzt-nzb+2
-
-#if defined( __parallel )
-                IF(rem_pe /= myid)   THEN
-                   CALL MPI_GET( data(nzb,j,i), nval, MPI_REAL, rem_pe, rem_offs, nval, MPI_REAL,  &
-                                 rmawin_3d, ierr)
-                ELSE
-                   data(:,j,i) = rmabuf_3d(:,j_remote,i_remote)
-                ENDIF
-#else
-                data(:,j,i) = array_3d(:,i_remote,j_remote)
-#endif
-             ENDDO
-          ENDDO
-          is = prerun_grid%nxr+1
-          ie = nxr
-          js = nys
-          je = nyn
-
-       ENDIF
+!--    Close RMA window to allow remote access
+       CALL MPI_WIN_FENCE( 0, rmawin_3d, ierr )
+#endif
+
+       is = nxl
+       ie = nxr
+       js = nys
+       je = nyn
 
        DO  i = is, ie
           DO  j = js, je
-             i_remote = MOD(i,nx_on_file+1)
-             j_remote = MOD(j,ny_on_file+1)
+             i_remote = MOD( i, nx_on_file+1 )
+             j_remote = MOD( j, ny_on_file+1 )
              rem_pe   = remote_pe(i_remote,j_remote)
              rem_offs = rma_offset(i_remote,j_remote) * ( nzt-nzb+2 )
@@ -1850,6 +1802,6 @@
 
     IF ( found )  THEN
-#if defined( __parallel )
        CALL rd_mpi_io_create_filetypes_3dsoil( nzb_soil, nzt_soil )
+#if defined( __parallel )
        CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
        IF ( sm_io%iam_io_pe )  THEN
@@ -1874,4 +1826,14 @@
        ENDIF
 
+#if defined( __parallel )
+      IF ( sm_io%is_sm_active() )  THEN
+         CALL MPI_WIN_FREE( win_3ds, ierr )
+      ELSE
+         DEALLOCATE( array_3d_soil )
+      ENDIF
+#else
+      DEALLOCATE( array_3d_soil )
+#endif
+
     ELSE
 
@@ -2042,5 +2004,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_real_2d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2107,5 +2070,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_int_2d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2182,5 +2146,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_int4_3d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2225,6 +2190,4 @@
                                       INT( (iog%nx+1), KIND = rd_offset_kind ) * isp
 
-    write(9,*) 'array_position int4_3d ',trim(name),' ',array_position
-
  END SUBROUTINE wrd_mpi_io_int4_3d
 
@@ -2250,5 +2213,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_int8_3d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2293,6 +2257,4 @@
                                       INT( (iog%nx+1), KIND = rd_offset_kind ) * dp
 
-    write(9,*) 'array_position int8_3d ',trim(name),' ',array_position
-
  END SUBROUTINE wrd_mpi_io_int8_3d
 
@@ -2318,5 +2280,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_real_3d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2395,5 +2358,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_real_3d_soil', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2402,7 +2366,5 @@
     header_array_index = header_array_index + 1
 
-#if defined( __parallel )
     CALL rd_mpi_io_create_filetypes_3dsoil( nzb_soil, nzt_soil )
-#endif
 
     IF ( include_total_domain_boundaries)  THEN
@@ -2432,7 +2394,17 @@
     ENDIF
     CALL sm_io%sm_node_barrier()
+
+    IF ( sm_io%is_sm_active() )  THEN
+       CALL MPI_WIN_FREE( win_3ds, ierr )
+    ELSE
+       DEALLOCATE( array_3d_soil )
+    ENDIF
+    IF ( sm_io%iam_io_pe )  THEN
+       CALL MPI_TYPE_FREE( ft_3dsoil, ierr )
+    ENDIF
 #else
     CALL posix_lseek( fh, array_position )
     CALL posix_write( fh, array_3d_soil, SIZE( array_3d_soil ) )
+    DEALLOCATE( array_3d_soil )
 #endif
 !
@@ -2589,12 +2561,12 @@
          CALL MPI_BCAST( data, SIZE( data ), MPI_REAL, 0, comm2d, ierr )
        ELSE
-          IF ( sm_io%iam_io_pe )  THEN
+          IF( sm_io%iam_io_pe )  THEN
              CALL MPI_FILE_SET_VIEW( fh, offset, MPI_BYTE, MPI_BYTE, 'native', MPI_INFO_NULL, ierr )
+          ENDIF
+          IF ( myid == 0 )  THEN
              CALL MPI_FILE_SEEK( fh, array_position, MPI_SEEK_SET, ierr )
-             CALL MPI_FILE_READ_ALL( fh, data, SIZE( data ), MPI_REAL, status, ierr )
+             CALL MPI_FILE_READ( fh, data, SIZE( data ), MPI_REAL, status, ierr )
           ENDIF
-          IF ( sm_io%is_sm_active() )  THEN
-             CALL MPI_BCAST( data, SIZE( data ), MPI_REAL, 0, sm_io%comm_shared, ierr )
-          ENDIF
+          CALL MPI_BCAST( data, SIZE( data ), MPI_REAL, 0, comm2d, ierr )
        ENDIF
 #else
@@ -2749,15 +2721,15 @@
              CALL MPI_FILE_READ_ALL( fh, data, SIZE( data), MPI_INTEGER, status, ierr )
           ENDIF
-          CALL MPI_BCAST( data, SIZE( data ), MPI_REAL, 0, comm2d, ierr )
+          CALL MPI_BCAST( data, SIZE( data ), MPI_INTEGER, 0, comm2d, ierr )
        ELSE
-          IF ( sm_io%iam_io_pe )  THEN
+          IF( sm_io%iam_io_pe )  THEN
              CALL MPI_FILE_SET_VIEW( fh, offset, MPI_BYTE, MPI_BYTE, 'native', MPI_INFO_NULL, ierr )
+          ENDIF
+          IF ( myid == 0 )  THEN
              CALL MPI_FILE_SEEK( fh, array_position, MPI_SEEK_SET, ierr )
-             CALL MPI_FILE_READ_ALL( fh, data, SIZE( data), MPI_INTEGER, status, ierr )
+             CALL MPI_FILE_READ( fh, data, SIZE( data), MPI_INTEGER, status, ierr )
           ENDIF
-          IF ( sm_io%is_sm_active() )  THEN
-             CALL MPI_BCAST( data, SIZE( data ), MPI_INTEGER, 0, sm_io%comm_shared, ierr )
-          ENDIF
-       ENDIF
+          CALL MPI_BCAST( data, SIZE( data ), MPI_INTEGER, 0, comm2d, ierr )
+        ENDIF
 #else
        CALL posix_lseek( fh, array_position )
@@ -2800,5 +2772,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_global_array_real_1d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -2939,5 +2912,6 @@
 
     IF ( header_array_index == max_nr_arrays )  THEN
-       STOP '+++ maximum number of 2d/3d-array entries in restart file header exceeded'
+       message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+       CALL message( 'wrd_mpi_io_global_array_int_1d', 'PA0585', 1, 2, 0, 6, 0 )
     ENDIF
 
@@ -3030,6 +3004,4 @@
        ENDDO
 
-       write(9,*) 'particle_size_read ',particle_size,array_size,array_position,sum(prt_global_index)
-
        ALLOCATE( prt_data(MAX(array_size,1)) )
 
@@ -3078,6 +3050,4 @@
        array_position = prt_nr_bytes
 
-       write(9,*) 'array_position after particle read ',array_position,prt_nr_bytes,rs
-
        DEALLOCATE( prt_data )
 
@@ -3092,6 +3062,8 @@
 ! ------------
 !> Read 1d-REAL surface data array with MPI-IO.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE rrd_mpi_io_surface( name, data, first_index )
+!> This is a recursive subroutine. In case of cyclic fill mode it may call itself for reading parts
+!> of the prerun grid.
+!--------------------------------------------------------------------------------------------------!
+ RECURSIVE SUBROUTINE rrd_mpi_io_surface( name, data, first_index )
 
     IMPLICIT NONE
@@ -3099,26 +3071,28 @@
     CHARACTER(LEN=*), INTENT(IN) ::  name            !<
 
+    INTEGER(iwp), OPTIONAL       ::  first_index     !<
+    INTEGER(iwp)                 ::  i               !<
+    INTEGER(iwp)                 ::  j               !<
+    INTEGER(iwp)                 ::  lo_first_index  !<
+
+#if defined( __parallel )
+    INTEGER(iwp)                 ::  buf_start       !<
     INTEGER(KIND=rd_offset_kind) ::  disp            !< displacement of actual indices
-    INTEGER(KIND=rd_offset_kind) ::  disp_f          !< displacement in file
-    INTEGER(KIND=rd_offset_kind) ::  disp_n          !< displacement of next column
-    INTEGER(iwp), OPTIONAL       ::  first_index     !<
-
-    INTEGER(iwp)                 ::  i               !<
-    INTEGER(iwp)                 ::  i_f             !<
-    INTEGER(iwp)                 ::  j               !<
-    INTEGER(iwp)                 ::  j_f             !<
-    INTEGER(iwp)                 ::  lo_first_index  !<
-    INTEGER(iwp)                 ::  nr_bytes        !<
-    INTEGER(iwp)                 ::  nr_bytes_f      !<
-    INTEGER(iwp)                 ::  nr_words        !<
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)  ::  status   !<
-#else
-    TYPE(C_PTR)                         ::  buf      !<
-#endif
-
-    LOGICAL                             ::  found    !<
+    INTEGER(iwp)                 ::  ie              !<
+    INTEGER(iwp)                 ::  ind_gb          !<
+    INTEGER(iwp)                 ::  ind_out         !<
+    INTEGER(iwp)                 ::  is              !<
+    INTEGER(iwp)                 ::  n               !<
+    INTEGER(iwp)                 ::  n_trans         !<
+
+    INTEGER(iwp),DIMENSION(0:numprocs-1) ::  lo_index  !<
+    INTEGER, DIMENSION(rd_status_size)   ::  status    !<
+#endif
+    LOGICAL                      ::  found  !<
 
     REAL(wp), INTENT(OUT), DIMENSION(:), TARGET ::  data  !<
+#if defined( __parallel )
+    REAL(wp),DIMENSION(:),ALLOCATABLE    ::  put_buffer  !<
+#endif
 
 
@@ -3132,6 +3106,11 @@
     DO  i = 1, tgh%nr_arrays
         IF ( TRIM( array_names(i) ) == TRIM( name ) )  THEN
+!
+!--        ATTENTION: The total_number_of_surface_values and wp MUST be INTERGER(8).
+!--        The compiler (at least Intel) first computes total_number_of_surface_values*wp
+!--        and then does the conversion to INTEGER(8).
+!--        This may lead to wrong results when total_number_of_surface_values*wp is > 2*10**6
            array_position = array_offset(i) + ( lo_first_index - 1 ) *                             &
-                            total_number_of_surface_values * wp
+                            INT( total_number_of_surface_values, idp ) * INT( wp, idp )
            found = .TRUE.
            EXIT
@@ -3139,80 +3118,116 @@
     ENDDO
 
-    disp   = -1
-    disp_f = -1
-    disp_n = -1
+!
+!-- In case of 2d-data, name is written only once
+    IF ( lo_first_index == 1 )  THEN
+
+       IF ( header_array_index == max_nr_arrays )  THEN
+          message_string = 'maximum number of 2d/3d-array entries in restart file header exceeded'
+          CALL message( 'rrd_mpi_io_surface', 'PA0585', 1, 2, 0, 6, 0 )
+       ENDIF
+
+       array_names(header_array_index)  = name
+       array_offset(header_array_index) = array_position
+       header_array_index = header_array_index + 1
+
+    ENDIF
+
     IF ( found )  THEN
-
        IF ( cyclic_fill_mode )  THEN
 
           CALL rrd_mpi_io_surface_cyclic_fill
+          RETURN
 
        ELSE
-
-          IF ( MAXVAL( m_global_start ) == -1 )   RETURN   ! Nothing to do on this PE
+#if defined( __parallel )
+!
+!--       Read data from restart file
+          CALL sm_io%sm_node_barrier() ! has no effect if I/O on limited number of cores is inactive
+          IF ( sm_io%iam_io_pe )  THEN
+             CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_surf, 'native',              &
+                                     MPI_INFO_NULL, ierr )
+             CALL MPI_FILE_READ_ALL ( fh, array_out, SIZE(array_out), MPI_REAL, status, ierr )
+          ENDIF
+          CALL sm_io%sm_node_barrier()
+
+!
+!--       Copy data into transfer buffer. Data is organized in a way that only one MPI_PUT to the
+!--       respective PE ist required.
+          ALLOCATE( put_buffer(SUM( transfer_index(4,:) )) )
+
+          ind_gb = 1
+          DO  i = 1, SIZE( local_indices, 2 )
+             ind_out = local_indices(1,i)
+             DO  j = 1, local_indices(2,i)
+                put_buffer(ind_gb) = array_out(ind_out)
+                ind_out = ind_out + 1
+                ind_gb  = ind_gb  + 1
+             ENDDO
+          ENDDO
+!
+!--       Transfer data from I/O PEs to the respective PEs to which they belong.
+          CALL MPI_WIN_FENCE( 0, win_surf, ierr )
+
+          buf_start = 1
+          DO  n = 0, numprocs-1
+             n_trans = transfer_index(4,n)
+             IF ( n_trans > 0 )  THEN
+                disp = transfer_index(3,n) - 1
+                CALL MPI_PUT( put_buffer(buf_start), n_trans, MPI_REAL, n, disp, n_trans, MPI_REAL,&
+                              win_surf, ierr)
+                buf_start = buf_start + n_trans
+             ENDIF
+          ENDDO
+
+          CALL MPI_WIN_FENCE( 0, win_surf, ierr )
+          DEALLOCATE( put_buffer )
+!
+!--       Copy from RMA window into output array (data) to allow transfering data to target PEs.
+!--       Check, if the number of surface values per grid cell match the index setup.
+          lo_index = thread_values
           DO  i = nxl, nxr
              DO  j = nys, nyn
-
-                IF ( m_global_start(j,i) > 0 )  THEN
-                   disp     = array_position+(m_global_start(j,i)-1) * wp
-                   nr_words = m_end_index(j,i)-m_start_index(j,i)+1
-                   nr_bytes = nr_words * wp
+                is = lo_index(target_thread(j,i)) + 1
+                ie = is + m_end_index(j,i) - m_start_index(j,i)
+                data(m_start_index(j,i):m_end_index(j,i)) = array_1d(is:ie)
+                lo_index(target_thread(j,i)) = lo_index(target_thread(j,i)) +                      &
+                                               e_end_index(j,i) - e_start_index(j,i) + 1
+!
+!--             TODO: Test can be removed later.
+                IF ( e_end_index(j,i)-e_start_index(j,i)+1 /= NINT( array_1d(is-1) ) )  THEN
+                   WRITE( 9, '(A,6I8)' ) 'Nr surface values does not match ', j, i,                &
+                                         e_start_index(j,i), e_end_index(j,i),                     &
+                                         e_end_index(j,i)-e_start_index(j,i)+1 ,                   &
+                                         NINT( array_1d(is-1) )
+                   FLUSH( 9 )
+                   CALL MPI_ABORT( comm2d, 1, ierr )
                 ENDIF
-                IF ( disp >= 0  .AND.  disp_f == -1 )  THEN   ! First entry
-                   disp_f     = disp
-                   nr_bytes_f = 0
-                   i_f = i
-                   j_f = j
-                ENDIF
-                IF ( j == nyn  .AND.  i == nxr )  THEN        ! Last entry
-                   disp_n = -1
-                   IF (  nr_bytes > 0 )  THEN
-                      nr_bytes_f = nr_bytes_f+nr_bytes
-                   ENDIF
-                ELSEIF ( j == nyn )  THEN                     ! Next x
-                   IF ( m_global_start(nys,i+1) > 0  .AND.  disp > 0 )  THEN
-                      disp_n = array_position + ( m_global_start(nys,i+1) - 1 ) * wp
-                   ELSE
-                      CYCLE
-                   ENDIF
-                ELSE
-                   IF ( m_global_start(j+1,i) > 0  .AND.  disp > 0 )  THEN
-                      disp_n = array_position + ( m_global_start(j+1,i) - 1 ) * wp
-                   ELSE
-                      CYCLE
-                   ENDIF
-                ENDIF
-
-
-                IF ( disp + nr_bytes == disp_n )  THEN        ! Contiguous block
-                   nr_bytes_f = nr_bytes_f + nr_bytes
-                ELSE                                          ! Read
-#if defined( __parallel )
-                   CALL MPI_FILE_SEEK( fhs, disp_f, MPI_SEEK_SET, ierr )
-                   nr_words = nr_bytes_f / wp
-                   CALL MPI_FILE_READ( fhs, data(m_start_index(j_f,i_f)), nr_words, MPI_REAL, status, &
-                      ierr )
-#else
-!
-!--                Use C_PTR here, because posix read does not work with indexed array
-                   buf = C_LOC( data(m_start_index(j_f,i_f)) )
-                   CALL posix_lseek( fh, disp_f )
-                   CALL posix_read( fh, buf, nr_bytes_f )
-#endif
-                   disp_f     = disp
-                   nr_bytes_f = nr_bytes
-                   i_f = i
-                   j_f = j
-                ENDIF
-
              ENDDO
           ENDDO
-       ENDIF
-
-
-    ELSE
-
-       message_string = 'surface array "' // TRIM( name ) // '" not found in restart file'
-       CALL message( 'rrd_mpi_io_surface', 'PA0722', 3, 2, 0, 6, 0 )
+
+
+#else
+          CALL posix_lseek( fh, array_position )
+          CALL posix_read( fh, array_out, SIZE(array_out) )
+
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                data(m_start_index(j,i):m_end_index(j,i)) =                                        &
+                                                   array_out(e_start_index(j,i)+1:e_end_index(j,i))
+!
+!--             TODO: Test can be removed later.
+                IF ( e_end_index(j,i)-e_start_index(j,i)+1 /= NINT(array_out(e_start_index(j,i))) )&
+                THEN
+                   WRITE( 9, '(A,6I8)' ) 'Nr surface values does not match ', j, i,                &
+                                         e_start_index(j,i), e_end_index(j,i),                     &
+                                         e_end_index(j,i)-e_start_index(j,i)+1,                    &
+                                         NINT( array_out(e_start_index(j,i)) )
+                   FLUSH( 9 )
+                   CALL ABORT()
+                ENDIF
+             ENDDO
+          ENDDO
+#endif
+       ENDIF
 
     ENDIF
@@ -3226,7 +3241,4 @@
        INTEGER(iwp) ::  i         !<
        INTEGER(iwp) ::  ie        !<
-#if defined( __parallel )
-       INTEGER(iwp) ::  ierr      !<
-#endif
        INTEGER(iwp) ::  is        !<
        INTEGER(iwp) ::  i_remote  !<
